﻿'use strict';

function ChatMessengerItem(userProviderKey, currentDate, chatHub, userSessions) {
    ChatItem.call(this, userProviderKey, currentDate, chatHub, userSessions);
    var ci = this;

    ci.isSelected = ko.observable(false);
    ci.isSelected.subscribe(function (newSpot) { ci.spot.call(ci, newSpot); } );
}

ChatMessengerItem.prototype = Object.create(ChatItem.prototype);
ChatMessengerItem.lastSpottedChatMessengerItemSessionId = null;


ChatMessengerItem.prototype.spot = function (newSpot) {
    var ci = this;

    if (!newSpot) {
        ci.viewModel().myUserSession().LastSpot = new Date();
        ci.viewModel().myUserSession.notifySubscribers();
    }

    if (ChatMessengerItem.lastSpottedChatMessengerItemSessionId) {
        ci.chatHub.server.spotUserSessions(ci.sessionId, ChatMessengerItem.lastSpottedChatMessengerItemSessionId).fail(function (error) {
            console.warn('spot: ' + error);
        });

        ChatMessengerItem.lastSpottedChatMessengerItemSessionId = null;
    }
    else {
        ChatMessengerItem.lastSpottedChatMessengerItemSessionId = ci.sessionId;
        setTimeout(function () {
            if (ChatMessengerItem.lastSpottedChatMessengerItemSessionId) {
                ci.chatHub.server.spotUserSessions(ChatMessengerItem.lastSpottedChatMessengerItemSessionId, null).fail(function (error) {
                    console.warn('spot: ' + error);
                });

                ChatMessengerItem.lastSpottedChatMessengerItemSessionId = null;
            }
        }, 0);

    }
};

ChatMessengerItem.prototype.createAndInitChatSessionViewModel = function (userSessions) {
    var ci = this;
    return new Promise(function (resolve, reject) {
        var viewModel = new ChatMessengerSessionViewModel(ci.userProviderKey, ci.sessionId);
        ci.viewModel(viewModel);
        viewModel.init(userSessions, ci.chatHub).then(function () {
            resolve();
        }).catch(function (error) {
            reject(error);
        });
    });
};

