﻿$(document).ready(function () {
    InitUploader($("#IdentifierForAsyncAttachments").val());

    $("#MySeparator").change(function () {
        SetSeparatorName(this);
    })

    $("#MySeparator").keyup(function () {
        SetSeparatorName(this);
    })
});

function SetSeparatorName(e) {
    var val = $(e).val();
    $("#NameSeparator").hide();
    if (val == " ") {
        $("#NameSeparator").text("mezera");
        $("#NameSeparator").show();
    }
    else if (val == "\t") {
        $("#NameSeparator").text("tabulátor");
        $("#NameSeparator").show();
    }
}

var uploader;

function InitUploader(identifierForAsyncAttachments) {

    uploader = new plupload.Uploader({
        runtimes: 'html5,flash,silverlight',
        url: RQ_URL + '/Customers/UploadImportAjax',
        browse_button: 'pickfiles',
        container: 'containerAttachments',
        max_file_size: '1024mb',
        chunk_size: '1024kb',
        unique_names: false,
        multiple_queues: false,
        multi_selection: false,
        flash_swf_url: RQ_URL + '/Scripts/plupload/Moxie.swf',
        silverlight_xap_url: RQ_URL + '/Scripts/plupload/Moxie.xap',
        multipart_params: { identifierForAsyncAttachments: identifierForAsyncAttachments },
        filters: [
       { title: "Excel Files", extensions: "csv" },
        ],
    });

    uploader.bind('Init', function (up, params) {
        $('#filelist').html("<ul id=\"filelistul\"></ul>");
    });

    uploader.init();

    uploader.bind('FilesAdded', function (up, files) {
        total_upload_files = 1;
        $('#filelist').empty();
    });

    uploader.bind('UploadProgress', function (up, file) {
        $('#up-progress').attr("style", "width: " + file.percent + "%;");
        $('#lbUploadFileSize').html(file.name + " - " + formatSize(file.loaded));
        $('#lbUploadPercentage').html(file.percent);
    });

    uploader.bind('Error', function (up, err) {
        if (err.code == -600)
            $('#filelist').append('<div class="valid-error">' + Localization_Error + ': ' + Localization_FileSizeIsGreaterThan + ' 1024 MB' + (err.file ? ', ' + Localization_File + ': ' + err.file.name : "") + '</div>');
        else
            $('#filelist').append("<div class='valid-error'>" + Localization_Customer_OnlyCsv + "</div>");

        up.refresh(); // Reposition Flash/Silverlight
    });

    var total_upload_files = 0;

    uploader.bind('QueueChanged', function (up, files) {
        total_upload_files = 1
        $("#upload-status").show();
        uploader.start();

    });

    uploader.bind('FileUploaded', function (up, file) {
        $('#liFile' + file.id + " b").html("100%");
        total_upload_files--;
        if (total_upload_files == 0) {
            filesUploaded = true;

            up.refresh();
            loadSeparator();
        }
    });
}

function loadSeparator() {
    if (filesUploaded) {
        OnAjaxBegin(Localization_Customer_LoadingData);
        $.ajax({
            url: RQ_URL + "/Customers/GetSeparator",
            type: "POST",
            dataType: "json",
            data: JSON.stringify({
                identifierForAsyncAttachments: $("#IdentifierForAsyncAttachments").val(),
                haveHeader: $("#HaveHeader").is(':checked'),
            }),
            contentType: "application/json; charset=utf-8",
            success: function (g) {
                if (g != null) {
                    $("#MySeparator").val(g);
                    $("#MySeparator").trigger("change");
                    $(".sepearator-validation-error").hide();
                    OnAjaxComplete();
                }
            },
            error: function (error) { alert(error.responseText); }
        });
    }
}



function formatSize(bytes) {
    if (bytes < 10 * 1024)
        return bytes + "&nbsp;B";
    else if (bytes < 10 * 1024 * 1024)
        return Math.round(bytes / 1024) + "&nbsp;kB";
    else
        return Math.round(bytes / 1024 / 1024) + "&nbsp;MB";
}