﻿var $lastUl = null;

$(document).ready(function () {
    var tbSearch = $('#search-input');
    tbSearch.on('input', function () { //This would fire every time the input changes, so when you paste something (even with right click), delete and type anything.
        clearTimeout($.data(this, 'timerGetAutocomplete'));
        var wait = setTimeout(GetAutocomplete, 700); //latence
        $(this).data('timerGetAutocomplete', wait);
    });

    tbSearch.on('search', function () { //reaguje na krizek v Chrome
        GetAutocomplete();
    });

    tbSearch.focus(function () {
        $(this).animate({ }, 'fast');
        //GetAutocomplete();
        var $searchInput = $("#search-input");
        var q = $searchInput.val();
        if (q.length >= 2) {
            $("#autocomplete_div").slideDown();
        }
    });

    tbSearch.focusout(function () {
        if (!$("#autocomplete_div").is(':visible')) {
            tbSearch.animate({ }, 'fast'); //click mimo prohlizec
        }
    });
    
    $('#autocomplete_div, #search-input').click(function (event) {
        event.stopPropagation(); // Prevent bubbling
    });

    $("html").click(function () {
        setTimeout(function () { //http://stackoverflow.com/questions/1094332/jquery-blur-fires-before-href
            HideResult();
            tbSearch.animate({ }, 'fast');
        }, 1);
    });

    $("#search-button").click(function () {
        window.location.href = RQ_URL + "/SupportCentre/SearchFor/" + $("#search-input").val();
    });

    ShowMvcErrors();
})

function OnCatchExeptionForAjaxFormFailure(xhr, status) {
    OnAjaxComplete(); //zavrem loading...
    alert(xhr.responseText);
}

function ShowSuccess(text) {
    //if (intervalID != null)
    //    window.clearInterval(intervalID);
    $('#lbSuccess').html(text);
    $('#ajax-success').fadeIn();
    if ($('#ajax-success').offset().top < $('html, body').scrollTop()) {
        $('html, body').scrollTop($('#ajax-success').offset().top);
    }

    setTimeout(function () {
        $("section#ajax-alert .alert.ok:not(.do-not-hide)").fadeOut('slow');
    }, 3000);

    //$('html, body').animate({
    //    scrollTop: $('#ajax-success').offset().top
    //});
}

function HideSuccess() {
    //window.clearInterval(intervalID);
    $('#ajax-success').fadeOut();
}

function ShowInformation(text) {
    $('#lbInformation').html(text);
    $('#ajax-information').fadeIn();
    if ($('#ajax-information').offset().top < $('html, body').scrollTop()) {
        $('html, body').scrollTop($('#ajax-information').offset().top);
    }
}

function HideInformation() {
    $('#ajax-information').fadeOut();
}

function ShowError(text) {
    $('#lbError').html(text);
    $('#ajax-error').fadeIn();
    if ($('#ajax-error').offset().top < $('html, body').scrollTop()) {
        $('html, body').scrollTop($('#ajax-error').offset().top);
    }
}

function HideError() {
    $('#ajax-error').fadeOut();
}

function ShowWarning(text) {
    $('#lbWarning').html(text);
    $('#ajax-warning').fadeIn();
    if ($('#ajax-warning').offset().top < $('html, body').scrollTop()) {
        $('html, body').scrollTop($('#ajax-warning').offset().top);
    }
}

function HideWarning() {
    $('#ajax-warning').fadeOut();
}

function HideAllMessageTypes() {
    HideSuccess();
    HideInformation();
    HideError();
    HideWarning();
}

function GetAutocomplete() {
    var $div = $("#autocomplete_div");
    var $searchInput = $("#search-input");

    var q = $searchInput.val();

    if (q.length >= 2) {
        if ($div.find('.loading-16').length == 0) {
            $div.prepend('<div class="loading-16"></div>');
        }

        if (!$div.is(':visible')) {
            $div.find("ul.result").remove();
            $div.slideDown();
        }

        $('#formSearchFor button[type="submit"]').prop('disabled', false);
        $("#autocomplete_div ul.not-found").hide();
        mandate = Math.random().toString(36).substring(7);
        LoadKnowledgeBase(q, mandate);
    } else {
        $('#formSearchFor button[type="submit"]').prop('disabled', true);
        HideResult();
    }
}

function ShowMvcErrors() {
    $.each($(".invalid-feedback > span"), function (key, value) {
        if ($(value).text() != "") {
            $(value).closest(".invalid-feedback").show();
        }
    });
}

function LoadKnowledgeBase(q, myMandate) {
    $.post(
        RQ_URL + '/Desktop/SearchForKnowledgeBaseAutocomplete',
        { searchText: q, onlyPublic: true },
        function (data) {
            if (myMandate == mandate) {
                $(".autocomplete_ul_articles").remove();

                if ($(data).length > 0) {
                    // creating list
                    var $ul = $("<ul></ul>", { class: "autocomplete_ul_articles result" });

                    // append knowledgebase title
                    $("<li></li>", { class: "main knowledgeBase-autocomplete", text: Localization_SearchBox_KnowledgeBase }).appendTo($ul);

                    $(data).each(function () {
                        if (this.Title === "showmore") {

                            var $li = $("<li class=\"showmore\"><span class='right'>" + Localization_SearchBox_TotalArticles + ": " + this.Id + "<span></li>");
                            var $a_link = $("<a></a>", { href: "javascript:void(0);", text: Localization_ShowAll });

                            $a_link.click(function () {
                                $("#SearchType").val(4);
                                $('#formSearchFor').submit();
                            });

                            $a_link.prependTo($li);
                            $li.appendTo($ul);
                        }
                        else {
                            var $li = $("<li></li>", { class: "result" });
                            var $a = $("<a></a>", { href: this.Url, text: this.Title, title: this.Title, class: "result" }).appendTo($li);
                            $li.appendTo($ul);
                        }
                    });

                    var splitedText = $.map(q.trim().split(' '), function (n, i) { return n.replace(/^\"/, "").replace(/\"$/, ""); }).filter(function (obj) { return obj.length >= 2 });
                    //$ul.find("li.result a").removeHighlight();
                    //$.each(splitedText, function (index, text) {
                    //    $ul.find("li.result a").highlight(text, true);
                    //});

                    InsertResultUl($ul, false);
                }
            }
        },
        "json"
    )
    .fail(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } })
    .done(function () {
        if (myMandate == mandate) { LoadSupportCenterArticles(q, myMandate); }
    });
}

function LoadSupportCenterArticles(q, myMandate) {
    $.post(
        RQ_URL + '/Desktop/SearchForSupportCentreArticleAutocomplete',
        { searchText: q },
        function (data) {
            if (myMandate == mandate) {
                $(".autocomplete_ul_supportcentrearticles").remove();

                if ($(data).length > 0) {
                    // creating list
                    var $ul = $("<ul></ul>", { class: "autocomplete_ul_supportcentrearticles result" });

                    // append knowledgebase title
                    $("<li></li>", { class: "main knowledgeBase-autocomplete", text: "Support center article" }).appendTo($ul);

                    $(data).each(function () {
                        if (this.Title === "showmore") {

                            var $li = $("<li class=\"showmore\"><span class='right'>" + Localization_SearchBox_TotalArticles + ": " + this.Id + "<span></li>");
                            var $a_link = $("<a></a>", { href: "javascript:void(0);", text: Localization_ShowAll });

                            $a_link.click(function () {
                                $("#SearchType").val(4);
                                $('#formSearchFor').submit();
                            });

                            $a_link.prependTo($li);
                            $li.appendTo($ul);
                        }
                        else {
                            var $li = $("<li></li>", { class: "result" });
                            var $a = $("<a></a>", { href: this.Url, text: this.Title, title: this.Title, class: "result" }).appendTo($li);
                            $li.appendTo($ul);
                        }
                    });

                    var splitedText = $.map(q.trim().split(' '), function (n, i) { return n.replace(/^\"/, "").replace(/\"$/, ""); }).filter(function (obj) { return obj.length >= 2 });
                    //$ul.find("li.result a").removeHighlight();
                    //$.each(splitedText, function (index, text) {
                    //    $ul.find("li.result a").highlight(text, true);
                    //});

                    InsertResultUl($ul, false);
                }
            }
        },
        "json"
    )
    .fail(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } })
    .done(function () {
        if (myMandate == mandate) {
            var $div = $("#autocomplete_div");

            if ($("#autocomplete_div li.result").length == 0) {
                $("#autocomplete_div ul.not-found").show();
            }

            //$div.find("div.loading-16").remove();
            $lastUl = null; //dalsi kolo od zacatku
        }
    });
}

function InsertResultUl($ul, insertAsFirst) {
    if ($lastUl != null && $lastUl.is(':visible')) { //visible, protoze uz muze byt ten div removnuty, pokud se nedojede az po posledni hledani, nenastavi se lastUl = null
        if (insertAsFirst) {
            var $div = $("#autocomplete_div");
            $ul.prependTo($div);
        }
        else {
            $ul.insertAfter($lastUl);
        }
    }
    else {
        var $div = $("#autocomplete_div");
        $ul.prependTo($div);
    }

    if (!insertAsFirst) {
        $lastUl = $ul;
    }
}

function HideResult() {
    $("#autocomplete_div").slideUp('fast');
}

function OnAjaxBegin(message) {
    $("#progressIndicator .waitingText").html(message === undefined || message.length === undefined ? Localization_LoadingPleaseWait : message);
    $("#progressIndicator").show();
}

function OnAjaxComplete() {
    $("#progressIndicator").hide();
}