﻿'use strict';

var callMainboard = {};

$(function () {
    var viewModel;

    function subscribeViewModel(newVideModel) {
        viewModel = newVideModel;
    }

    function getSubscribedViewModel() {
        return viewModel;
    }

    function initCallPanelDialog() {
        $("#dialog-callPanel").dialog({
            autoOpen: false,
            resizable: false,
            width: "auto",
            height: "auto",
            modal: true,
            buttons: {
                'Zavřít': function () {
                    $(this).dialog("close");
                }
            }//,
            //close: function (e) {
                
            //}
        });
    }

    function openCallPanelDialog() {
        $("#dialog-callPanel").dialog('open');
    }

    function initDOM() {
        ko.bindingHandlers.bootstrapSwitch = {
            init: function (element, valueAccessor, allBindingsAccessor) {
                //initialize bootstrapSwitch
                $(element).bootstrapSwitch(/*allBindingsAccessor().bootstrapSwitchOptions*//*{
                    onSwitchChange: function (e, state) {
                        var clickFunc = allBindingsAccessor().click;
                        if (typeof clickFunc === 'function')
                            clickFunc(ko.dataFor(this));
                    }
                }*/);

                // setting initial value
                $(element).bootstrapSwitch('state', valueAccessor()());

                //handle the field changing
                $(element).on('switchChange.bootstrapSwitch', function (event, state) {
                    var observable = valueAccessor();
                    observable(state);
                });

                // Adding component options
                var options = allBindingsAccessor().bootstrapSwitchOptions || {};
                for (var property in options) {
                    $(element).bootstrapSwitch(property, ko.utils.unwrapObservable(options[property]));
                }

                //handle disposal (if KO removes by the template binding)
                ko.utils.domNodeDisposal.addDisposeCallback(element, function () {
                    $(element).bootstrapSwitch("destroy");
                });

            },
            //update the control when the view model changes
            update: function (element, valueAccessor, allBindingsAccessor) {
                var value = ko.utils.unwrapObservable(valueAccessor());

                // Adding component options
                var options = allBindingsAccessor().bootstrapSwitchOptions || {};
                for (var property in options) {
                    $(element).bootstrapSwitch(property, ko.utils.unwrapObservable(options[property]));
                }

                $(element).bootstrapSwitch("state", value);
            }
        };


        $("#callSum").click(function (e) {
            openCallPanelDialog();
        });

        $("#callPauses").on("select2:select", function (e) {
            viewModel.selectPause();
        });
    }

    function pauseTemplate(data) {
        return $('<div></div>', {
            "class": "vertical-center-container",
            html: [
            $('<div></div>', {
                "class": "color-indication",
                css: { "background": data.id !== callSummary.NO_PAUSE_ID ? "red" : "green", "margin": "2px;" }
            }),
            $('<span></span>', {
                css: { "padding": "0px 6px" },
                text: data.id !== callSummary.NO_PAUSE_ID ? data.text : 'Žádná pauza'
            })]
        });
    }

    //ready
    initDOM();
    initCallPanelDialog();
    callMainboard.subscribeViewModel = subscribeViewModel;
    callMainboard.getSubscribedViewModel = getSubscribedViewModel;
    callMainboard.pauseTemplate = pauseTemplate;
});